(* Ausgabe eines Strings ber die serielle Schnittstelle
   in festen Zeitabstnden:
   SENDCOM <String> [<Zeit> [<ComNr> [<baud>]]]
     (Standardwerte: Zeit = 5s, ComNr = 1, baud = 4800)
     (String ='Z' ==> Zhler)
   J. Rathlev, Sep. 2000 *)

uses TpCom, Crt;

const
  ComNr : integer = 1;
  DTime : integer = 5;
  Baud  : integer = 4800;

{ ---------------------------------------------------------------- }
(* Integer-Zahl in String umsetzen *)
function StrInt (x : longint;
                 n : integer) : string;
(* n > 0 : Anzahl der Stellen
     = 0 : unformatiert
     < 0 : unformatiert mit Dreiergruppierung *)
var
  s   : string;
  i,j : integer;
begin
  if n<=0 then str(x,s) else str (x:n,s);
  if n<0 then begin
    i:=succ(length(s));
    j:=i;
    while (j>4) do begin
      dec(j,3); insert (' ',s,j);
      end;
    end;
  StrInt:=s;
  end;

{ ---------------------------------------------------------------- }
var
  s    : string;
  i,ic : integer;
  stat : word;
  count,
  ende : boolean;
  n    : longint;
begin
  if ParamCount>0 then begin
    s:=ParamStr(1);
    if Paramcount>1 then begin
      val(ParamStr(2),i,ic);
      if ic=0 then DTime:=i;
      if Paramcount>2 then begin
        val(ParamStr(3),i,ic);
        if ic=0 then ComNr:=i;
        if Paramcount>3 then begin
          val(ParamStr(4),i,ic);
          if ic=0 then Baud:=i;
         end;
       end;
     end;
    end
  else s:='Test serielle Schnittstelle ('+StrInt(DTime,0)+'s)';
  writeln ('Ausgabe nach COM',ComNr);
  InitCom (ComNr);
  ComInit (baud,'n',8,1,stat);
  n:=0; count:=Upcase(s[1])='Z';
  repeat
    delay (1000*DTime);
    if count then s:=Strint(n,10);
    inc(n);
    writeln ('Sende: ',s,' - ',ComSndBuf);
    ComWrStr (s); ComWrCrLf;
    if keypressed then begin
      ende:=readkey=#$1b;
      if not ende then begin
        writeln ('--- Pause ---');
        ende:=readkey=#$1b;
        end;
      end
    else ende:=false;
    until ende;
  ComRls;
  end.
